import requests
from requests.auth import HTTPBasicAuth
import logging
import json
import base64

auth=HTTPBasicAuth('shumee_integration_API', 'R!V)8$Y2zB3v')

#webhhook
def get_invoice_from_baselinker(baselinker_order_id):
    logging.info('get_invoice_from_baselinker')
    print('get_invoice_from_baselinker')
    parameters = {
        "order_id": baselinker_order_id
    }  
    data = {
        'token': "3001458-3006626-L61DQOGCX4XJFS6KB8HY63VR8L8BS0LYK8ICVKNYYYXW5DQMJV164W0AT9KNZN3E",
        'method': 'getInvoices',
        'parameters': json.dumps(parameters)
    }
    r = requests.post("https://api.baselinker.com/connector.php", data=data)
    invoice_id = r.json()['invoices'][0]['invoice_id']
    print(f"{r.status_code} {r.text}")
    logging.info((f"{r.status_code} {r.text}"))
    parameters = {
        "invoice_id": invoice_id
    }  
    data = {
        'token': "3001458-3006626-L61DQOGCX4XJFS6KB8HY63VR8L8BS0LYK8ICVKNYYYXW5DQMJV164W0AT9KNZN3E",
        'method': 'getInvoiceFile',
        'parameters': json.dumps(parameters)
    }
    r = requests.post("https://api.baselinker.com/connector.php", data=data)
    print(f"{r.status_code} {r.text}")
    logging.info(f"{r.status_code} {r.text}")
    return r.json()['invoice'].replace('data:', '')

def post_cons_in_status_shipped(code, invoice, tracking):
    print(f"post_cons_in_status_shipped")
    logging.info(f"post_cons_in_status_shipped")
    data = {
        "@odata.context": "$metadata#Consignments/$entity",
        "code": code,
        "status": {
            "code": "SHIPPED_TO_CUSTOMER"
        },
        "shippingTrackingUrls": f"https://www.dpdgroup.com/si/mydpd/my-parcels/incoming?parcelNumber={tracking}",
        "invoices": [{
            "code": code+"_invoice01",
            "realFileName": code+".pdf",
            "mime": "application/pdf",
            "payload": invoice
        }]
    }
    #print(data)
    r = requests.post("https://stage-api.shoppster.com/odata2webservices/InboundExtDropshippingConsignment/Consignments", json = data, auth = auth)
    print(f"{r.status_code} {r.text}")
    logging.info((f"{r.status_code} {r.text}"))
    return r.text

def read_pdf_to_base64(file_path):
    with open(file_path, "rb") as pdf_file:
        # Read the PDF file as binary
        pdf_data = pdf_file.read()
        # Encode the binary data to base64
        base64_encoded_pdf = base64.b64encode(pdf_data).decode('utf-8')
    return base64_encoded_pdf

def execute(baselinker_order_id, code, tracking):
    #invoice = get_invoice_from_baselinker(baselinker_order_id)
    invoice = read_pdf_to_base64(code+'.pdf')
    post_cons_in_status_shipped(code, invoice, tracking)
    
if __name__ == "__main__":
    #execute('a', 'S000004007209_0')
    execute('a', 'S000004100587_0', '13459301060126')
    execute('a', 'S000004100591_0', '13459301057787')
    execute('a', 'S000004100704_0', '13459301057204')